#ifndef UTILS_ENDIAN_H
#define UTILS_ENDIAN_H

#include <stdint.h>
#include <endian.h>
#include <string.h>

#define cpu_to_le16	htole16
#define cpu_to_le32	htole32
#define cpu_to_le64	htole64

#define le16_to_cpu	le16toh
#define le32_to_cpu	le32toh
#define le64_to_cpu	le64toh

#define rol64(x, s)	(((x) << (s)) | (x) >> ((64 - (s)) & 63))

static inline uint64_t get_unaligned_le64(const unsigned char *name)
{
	size_t s;
	uint64_t a = 0;
	for (s = 0; s < 8; s++) {
		a |= (uint64_t)name[s] << (s * 8);
	}
	return a;
}

#endif
